Index: issm/trunk/src/m/classes/initialization.py
===================================================================
--- issm/trunk/src/m/classes/initialization.py	(revision 25994)
+++ issm/trunk/src/m/classes/initialization.py	(revision 26744)
@@ -11,33 +11,36 @@
 
     Usage:
-    initialization = initialization()
+        initialization = initialization()
     """
 
-    def __init__(self):  # {{{
+    def __init__(self): #{{{
         self.vx = np.nan
         self.vy = np.nan
         self.vz = np.nan
         self.vel = np.nan
-        self.enthalpy = np.nan
         self.pressure = np.nan
         self.temperature = np.nan
+        self.enthalpy = np.nan
         self.waterfraction = np.nan
-        self.watercolumn = np.nan
         self.sediment_head = np.nan
         self.epl_head = np.nan
         self.epl_thickness = np.nan
+        self.watercolumn = np.nan
         self.hydraulic_potential = np.nan
         self.channelarea = np.nan
+        self.sealevel = np.nan
+        self.bottompressure = np.nan
+        self.dsl = np.nan
+        self.str = np.nan
+        self.sample = np.nan
 
-        #set defaults
         self.setdefaultparameters()
     #}}}
-
-    def __repr__(self):  # {{{
+    def __repr__(self): #{{{
         s = '   initial field values:\n'
-        s += '{}\n'.format(fielddisplay(self, 'vx', 'x component of velocity [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'vy', 'y component of velocity [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'vz', 'z component of velocity [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'vel', 'velocity norm [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'vx', 'x component of velocity [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'vy', 'y component of velocity [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'vz', 'z component of velocity [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'vel', 'velocity norm [m/yr]'))
         s += '{}\n'.format(fielddisplay(self, 'pressure', 'pressure [Pa]'))
         s += '{}\n'.format(fielddisplay(self, 'temperature', 'temperature [K]'))
@@ -50,35 +53,11 @@
         s += '{}\n'.format(fielddisplay(self, 'hydraulic_potential', 'Hydraulic potential (for GlaDS) [Pa]'))
         s += '{}\n'.format(fielddisplay(self, 'channelarea', 'subglaciale water channel area (for GlaDS) [m2]'))
+        s += '{}\n'.format(fielddisplay(self,'sample', 'Realization of a Gaussian random field'))
         return s
     #}}}
-
-    def extrude(self, md):  # {{{
-        self.vx = project3d(md, 'vector', self.vx, 'type', 'node')
-        self.vy = project3d(md, 'vector', self.vy, 'type', 'node')
-        self.vz = project3d(md, 'vector', self.vz, 'type', 'node')
-        self.vel = project3d(md, 'vector', self.vel, 'type', 'node')
-        self.temperature = project3d(md, 'vector', self.temperature, 'type', 'node')
-        self.enthalpy = project3d(md, 'vector', self.enthalpy, 'type', 'node')
-        self.waterfraction = project3d(md, 'vector', self.waterfraction, 'type', 'node')
-        self.watercolumn = project3d(md, 'vector', self.watercolumn, 'type', 'node')
-        self.sediment_head = project3d(md, 'vector', self.sediment_head, 'type', 'node', 'layer', 1)
-        self.epl_head = project3d(md, 'vector', self.epl_head, 'type', 'node', 'layer', 1)
-        self.epl_thickness = project3d(md, 'vector', self.epl_thickness, 'type', 'node', 'layer', 1)
-
-        #Lithostatic pressure by default
-        if np.ndim(md.geometry.surface) == 2:
-            print('Reshaping md.geometry.surface for your convenience but you should fix it in your model set up')
-            self.pressure = md.constants.g * md.materials.rho_ice * (md.geometry.surface.reshape(-1, ) - md.mesh.z)
-        else:
-            self.pressure = md.constants.g * md.materials.rho_ice * (md.geometry.surface - md.mesh.z)
-
-        return self
+    def setdefaultparameters(self): #{{{
+        return
     #}}}
-
-    def setdefaultparameters(self):  # {{{
-        return self
-    #}}}
-
-    def checkconsistency(self, md, solution, analyses):  # {{{
+    def checkconsistency(self, md, solution, analyses): #{{{
         if 'StressbalanceAnalysis' in analyses and not solution == 'TransientSolution' and not md.transient.isstressbalance:
             if not np.any(np.logical_or(np.isnan(md.initialization.vx), np.isnan(md.initialization.vy))):
@@ -88,4 +67,9 @@
             md = checkfield(md, 'fieldname', 'initialization.vx', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
             md = checkfield(md, 'fieldname', 'initialization.vy', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+        if 'OceantransportAnalysis' in analyses:
+            if solution == 'TransientSolution' and md.transient.isslc and md.transient.isoceantransport:
+                md = checkfield(md, 'fieldname', 'initialization.bottompressure', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+                md = checkfield(md, 'fieldname', 'initialization.dsl', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+                md = checkfield(md, 'fieldname', 'initialization.str', 'NaN', 1, 'Inf', 1, 'size', [1])
         if 'BalancethicknessAnalysis' in analyses and solution == 'BalancethicknessSolution':
             md = checkfield(md, 'fieldname', 'initialization.vx', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
@@ -110,13 +94,12 @@
         if 'HydrologyShreveAnalysis' in analyses:
             if hasattr(md.hydrology, 'hydrologyshreve'):
+                if (solution == 'TransientSolution' and md.transient.ishydrology) or solution == 'HydrologySolution':
+                    md = checkfield(md, 'fieldname', 'initialization.watercolumn', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+        if 'HydrologyTwsAnalysis' in analyses:
+            if hasattr(md.hydrology, 'hydrologytws'):
                 md = checkfield(md, 'fieldname', 'initialization.watercolumn', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-        if 'HydrologyDCInefficientAnalysis' in analyses:
-            if hasattr(md.hydrology, 'hydrologydc'):
-                md = checkfield(md, 'fieldname', 'initialization.sediment_head', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-        if 'HydrologyDCEfficientAnalysis' in analyses:
-            if hasattr(md.hydrology, 'hydrologydc'):
-                if md.hydrology.isefficientlayer == 1:
-                    md = checkfield(md, 'fieldname', 'initialization.epl_head', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-                    md = checkfield(md, 'fieldname', 'initialization.epl_thickness', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+        if 'SealevelchangeAnalysis' in analyses:
+            if solution == 'TransientSolution' and md.transient.isslc:
+                md = checkfield(md, 'fieldname', 'initialization.sealevel', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
         if 'HydrologyGlaDSAnalysis' in analyses:
             if hasattr(md.hydrology, 'hydrologyglads'):
@@ -124,13 +107,20 @@
                 md = checkfield(md, 'fieldname', 'initialization.hydraulic_potential', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
                 md = checkfield(md, 'fieldname', 'initialization.channelarea', 'NaN', 1, 'Inf', 1, '>=', 0, 'size', [md.mesh.numberofelements])
+        if 'SamplingAnalysis' in analyses and not solution == 'TransientSolution' and not md.transient.issampling:
+            if np.any(np.isnan(md.initialization.sample)):
+                md = checkfield(md, 'fieldname', 'initialization.sample', 'NaN', 1,'Inf', 1, 'size', [md.mesh.numberofvertices])
         return md
-    # }}}
+    #}}}
+    def marshall(self, prefix, md, fid): #{{{
+        yts = md.constants.yts
 
-    def marshall(self, prefix, md, fid):  # {{{
-        yts = md.constants.yts
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'vx', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'vy', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'vz', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'vx', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'vy', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'vz', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'pressure', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'sealevel', 'format', 'DoubleMat', 'mattype', 1,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'bottompressure', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'str', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'dsl', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'temperature', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'waterfraction', 'format', 'DoubleMat', 'mattype', 1)
@@ -141,11 +131,40 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'channelarea', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'hydraulic_potential', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'sample', 'format', 'DoubleMat', 'mattype', 1)
+
         if md.thermal.isenthalpy:
             if (np.size(self.enthalpy) <= 1):
+                # Reconstruct enthalpy
                 tpmp = md.materials.meltingpoint - md.materials.beta * md.initialization.pressure
-                pos = np.nonzero(md.initialization.waterfraction > 0.)[0]
+                pos = np.where(md.initialization.waterfraction > 0)[0]
                 self.enthalpy = md.materials.heatcapacity * (md.initialization.temperature - md.constants.referencetemperature)
-                self.enthalpy[pos] = md.materials.heatcapacity * (tpmp[pos].reshape(-1, ) - md.constants.referencetemperature) + md.materials.latentheat * md.initialization.waterfraction[pos].reshape(-1, )
+                self.enthalpy[pos] = md.materials.heatcapacity * (tpmp[pos].reshape(-1,) - md.constants.referencetemperature) + md.materials.latentheat * md.initialization.waterfraction[pos].reshape(-1,)
 
             WriteData(fid, prefix, 'data', self.enthalpy, 'format', 'DoubleMat', 'mattype', 1, 'name', 'md.initialization.enthalpy')
-    # }}}
+    #}}}
+    def extrude(self, md): #{{{
+        self.vx = project3d(md, 'vector', self.vx, 'type', 'node')
+        self.vy = project3d(md, 'vector', self.vy, 'type', 'node')
+        self.vz = project3d(md, 'vector', self.vz, 'type', 'node')
+        self.vel = project3d(md, 'vector', self.vel, 'type', 'node')
+        self.temperature = project3d(md, 'vector', self.temperature, 'type', 'node')
+        self.enthalpy = project3d(md, 'vector', self.enthalpy, 'type', 'node')
+        self.waterfraction = project3d(md, 'vector', self.waterfraction, 'type', 'node')
+        self.watercolumn = project3d(md, 'vector', self.watercolumn, 'type', 'node')
+        self.sediment_head = project3d(md, 'vector', self.sediment_head, 'type', 'node', 'layer', 1)
+        self.epl_head = project3d(md, 'vector', self.epl_head, 'type', 'node', 'layer', 1)
+        self.epl_thickness = project3d(md, 'vector', self.epl_thickness, 'type', 'node', 'layer', 1)
+        self.sealevel = project3d(md, 'vector', self.sealevel, 'type', 'node', 'layer', 1)
+        self.bottompressure = project3d(md, 'vector', self.bottompressure, 'type', 'node', 'layer', 1)
+        self.dsl = project3d(md, 'vector', self.dsl, 'type', 'node', 'layer', 1)
+        self.str = project3d(md, 'vector', self.str, 'type', 'node', 'layer', 1)
+
+        # Lithostatic pressure by default
+        if np.ndim(md.geometry.surface) == 2:
+            print('Reshaping md.geometry.surface for your convenience but you should fix it in your model set up')
+            self.pressure = md.constants.g * md.materials.rho_ice * (md.geometry.surface.reshape(-1, 1) - md.mesh.z)
+        else:
+            self.pressure = md.constants.g * md.materials.rho_ice * (md.geometry.surface - md.mesh.z)
+
+        return self
+    #}}}
Index: issm/trunk/src/m/classes/inversion.js
===================================================================
--- issm/trunk/src/m/classes/inversion.js	(revision 25994)
+++ issm/trunk/src/m/classes/inversion.js	(revision 26744)
@@ -140,4 +140,5 @@
 			WriteData(fid,prefix,'object',this,'fieldname','iscontrol','format','Boolean');
 			WriteData(fid,prefix,'object',this,'fieldname','incomplete_adjoint','format','Boolean');
+			WriteData(fid,prefix,'object',this,'fieldname','vel_obs','format','DoubleMat','mattype',1,'scale',1/yts);
 			if (!this.iscontrol) return;
 			WriteData(fid,prefix,'object',this,'fieldname','nsteps','format','Integer');
Index: issm/trunk/src/m/classes/inversion.m
===================================================================
--- issm/trunk/src/m/classes/inversion.m	(revision 25994)
+++ issm/trunk/src/m/classes/inversion.m	(revision 26744)
@@ -99,11 +99,11 @@
 			md = checkfield(md,'fieldname','inversion.cost_functions_coefficients','size',[md.mesh.numberofvertices num_costfunc],'>=',0);
 			md = checkfield(md,'fieldname','inversion.gradient_scaling','size',[md.inversion.nsteps num_controls]);
-			md = checkfield(md,'fieldname','inversion.min_parameters','size',[md.mesh.numberofvertices num_controls]);
-			md = checkfield(md,'fieldname','inversion.max_parameters','size',[md.mesh.numberofvertices num_controls]);
+			md = checkfield(md,'fieldname','inversion.min_parameters','size',[NaN num_controls]);
+			md = checkfield(md,'fieldname','inversion.max_parameters','size',[NaN num_controls]);
 
 			%Only SSA, HO and FS are supported right now
 			if strcmp(solution,'StressbalanceSolution')
-				if ~(md.flowequation.isSSA || md.flowequation.isHO || md.flowequation.isFS || md.flowequation.isL1L2),
-					md = checkmessage(md,['inversion can only be performed for SSA, HO or FS ice flow models']);
+				if ~(md.flowequation.isSSA || md.flowequation.isMLHO || md.flowequation.isHO || md.flowequation.isFS || md.flowequation.isL1L2),
+					md = checkmessage(md,['inversion can only be performed for SSA, MLHO, HO or FS ice flow models']);
 				end
 			end
Index: issm/trunk/src/m/classes/inversion.py
===================================================================
--- issm/trunk/src/m/classes/inversion.py	(revision 25994)
+++ issm/trunk/src/m/classes/inversion.py	(revision 26744)
@@ -138,6 +138,6 @@
         # Only SSA, HO and FS are supported right now
         if solution == 'StressbalanceSolution':
-            if not (md.flowequation.isSSA or md.flowequation.isHO or md.flowequation.isFS or md.flowequation.isL1L2):
-                md.checkmessage("'inversion can only be performed for SSA, HO or FS ice flow models")
+            if not (md.flowequation.isSSA or md.flowequation.isMLHO or md.flowequation.isHO or md.flowequation.isFS or md.flowequation.isL1L2):
+                md.checkmessage("'inversion can only be performed for SSA, MLHO, HO or FS ice flow models")
         if solution == 'BalancethicknessSolution':
             md = checkfield(md, 'fieldname', 'inversion.thickness_obs', 'size', [md.mesh.numberofvertices], 'NaN', 1, 'Inf', 1)
Index: issm/trunk/src/m/classes/issmsettings.js
===================================================================
--- issm/trunk/src/m/classes/issmsettings.js	(revision 25994)
+++ issm/trunk/src/m/classes/issmsettings.js	(revision 26744)
@@ -5,90 +5,95 @@
 
 function issmsettings (){
-	//methods
-	this.setdefaultparameters = function(){// {{{
-		//are we short in memory ? (0 faster but requires more memory)
-		this.lowmem=0;
+    //methods
+    this.setdefaultparameters = function(){// {{{
+        //are we short in memory ? (0 faster but requires more memory)
+        this.lowmem=0;
 
-		//i/o:
-		this.io_gather=1;
+        //i/o:
+        this.io_gather=1;
 
-		//results frequency by default every step
-		this.output_frequency=1;
+        //results frequency by default every step
+        this.output_frequency=1;
 
-		//checkpoints frequency, by default never: 
-		this.checkpoint_frequency=0;
+        //coupling frequency of the stress balance solver by default every step
+        this.sb_coupling_frequency=1;
 
-		//this option can be activated to load automatically the results
-		//onto the model after a parallel run by waiting for the lock file
-		//N minutes that is generated once the solution has converged
-		//0 to deactivate
-		this.waitonlock=Infinity;
+        //checkpoints frequency, by default never:
+        this.checkpoint_frequency=0;
 
-		//upload options: 
-		upload_port         = 0;
-		
-		//throw an error if solver residue exceeds this value
-		this.solver_residue_threshold=1e-6;
+        //this option can be activated to load automatically the results
+        //onto the model after a parallel run by waiting for the lock file
+        //N minutes that is generated once the solution has converged
+        //0 to deactivate
+        this.waitonlock=Infinity;
 
-	}// }}}
-	this.disp= function(){// {{{
-		console.log(sprintf('   issmsettings class echo:'));
-		
-		fielddisplay(this,'results_on_nodes','results are output for all the nodes of each element');
-		fielddisplay(this,'io_gather','I/O gathering strategy for result outputs (default 1)');
-		fielddisplay(this,'lowmem','is the memory limited ? (0 or 1)');
-		fielddisplay(this,'output_frequency','frequency at which results are saved in all solutions with multiple time_steps');
-		fielddisplay(this,'checkpoint_frequency','frequency at which the runs are being recorded, allowing for a restart');
-		fielddisplay(this,'waitonlock','maximum number of minutes to wait for batch results (NaN to deactivate)');
-		fielddisplay(this,'upload_server','server hostname where model should be uploaded');
-		fielddisplay(this,'upload_path','path on server where model should be uploaded');
-		fielddisplay(this,'upload_login','server login');
-		fielddisplay(this,'upload_port','port login (default is 0)');
-		fielddisplay(this,'upload_filename','unique id generated when uploading the file to server');
-		fielddisplay(this,'solver_residue_threshold','throw an error if solver residue exceeds this value');
+        //upload options:
+        this.upload_port         = 0;
+
+        //throw an error if solver residue exceeds this value
+        this.solver_residue_threshold=1e-6;
+
+    }// }}}
+    this.disp= function(){// {{{
+        console.log(sprintf('   issmsettings class echo:'));
+
+        fielddisplay(this,'results_on_nodes','results are output for all the nodes of each element');
+        fielddisplay(this,'io_gather','I/O gathering strategy for result outputs (default 1)');
+        fielddisplay(this,'lowmem','is the memory limited ? (0 or 1)');
+        fielddisplay(this,'output_frequency','frequency at which results are saved in all solutions with multiple time_steps');
+        fielddisplay(this,'checkpoint_frequency','frequency at which the runs are being recorded, allowing for a restart');
+        fielddisplay(this,'waitonlock','maximum number of minutes to wait for batch results (NaN to deactivate)');
+        fielddisplay(this,'upload_server','server hostname where model should be uploaded');
+        fielddisplay(this,'upload_path','path on server where model should be uploaded');
+        fielddisplay(this,'upload_login','server login');
+        fielddisplay(this,'upload_port','port login (default is 0)');
+        fielddisplay(this,'upload_filename','unique id generated when uploading the file to server');
+        fielddisplay(this,'solver_residue_threshold','throw an error if solver residue exceeds this value');
 
 
-	}// }}}
-	this.classname= function(){// {{{
-		return "issmsettings";
+    }// }}}
+    this.classname= function(){// {{{
+        return "issmsettings";
 
-	}// }}}
-		this.checkconsistency = function(md,solution,analyses) { // {{{
+    }// }}}
+	this.checkconsistency = function(md,solution,analyses) { // {{{
 
-			checkfield(md,'fieldname','settings.results_on_nodes','numel',[1],'values',[0, 1]);
-			checkfield(md,'fieldname','settings.io_gather','numel',[1],'values',[0, 1]);
-			checkfield(md,'fieldname','settings.lowmem','numel',[1],'values',[0, 1]);
-			checkfield(md,'fieldname','settings.output_frequency','numel',[1],'>=',1);
-			checkfield(md,'fieldname','settings.checkpoint_frequency','numel',[1],'>=',0);
-			checkfield(md,'fieldname','settings.waitonlock','numel',[1]);
-			checkfield(md,'fieldname','settings.solver_residue_threshold','numel',[1],'>',0);
-		} // }}}
-		this.marshall=function(md,prefix,fid) { //{{{
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','results_on_nodes','format','Boolean');
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','io_gather','format','Boolean');
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','lowmem','format','Boolean');
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','output_frequency','format','Integer');
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','checkpoint_frequency','format','Integer');
-			WriteData(fid,prefix,'object',this,'class','settings','fieldname','solver_residue_threshold','format','Double');
-			if (this.waitonlock>0) WriteData(fid,prefix,'name','md.settings.waitonlock','data',true,'format','Boolean');
-			else WriteData(fid,prefix,'name','md.settings.waitonlock','data',false,'format','Boolean');
-		}//}}}
-		this.fix=function() { //{{{
-		}//}}}
-	//properties 
-	// {{{
-	this.results_on_nodes    = 0;
-	this.io_gather           = 0;
-	this.lowmem              = 0;
-	this.output_frequency    = 0;
-	this.checkpoint_frequency   = 0;
-	this.waitonlock          = 0;
-	this.upload_server       = '';
-	this.upload_path         = '';
-	this.upload_login        = '';
-	this.upload_port         = 0;
-	this.upload_filename     = '';
-	this.solver_residue_threshold = 0;
-	this.setdefaultparameters();
-	//}}}
+		checkfield(md,'fieldname','settings.results_on_nodes','stringrow',1);
+		checkfield(md,'fieldname','settings.io_gather','numel',[1],'values',[0, 1]);
+		checkfield(md,'fieldname','settings.lowmem','numel',[1],'values',[0, 1]);
+		checkfield(md,'fieldname','settings.output_frequency','numel',[1],'>=',1);
+		checkfield(md,'fieldname','settings.sb_coupling_frequency','numel',[1],'>=',1);
+		checkfield(md,'fieldname','settings.checkpoint_frequency','numel',[1],'>=',0);
+		checkfield(md,'fieldname','settings.waitonlock','numel',[1]);
+		checkfield(md,'fieldname','settings.solver_residue_threshold','numel',[1],'>',0);
+	} // }}}
+	this.marshall=function(md,prefix,fid) { //{{{
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','results_on_nodes','format','StringArray');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','io_gather','format','Boolean');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','lowmem','format','Boolean');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','output_frequency','format','Integer');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','sb_coupling_frequency','format','Integer');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','checkpoint_frequency','format','Integer');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','waitonlock','data',this.waitonlock>0,'format','Boolean');
+		WriteData(fid,prefix,'object',this,'class','settings','fieldname','solver_residue_threshold','format','Double');
+	}//}}}
+	this.fix=function() { //{{{
+	}//}}}
+	//properties
+    // {{{
+    this.results_on_nodes        = '';
+    this.io_gather               = 0;
+    this.lowmem                  = 0;
+    this.output_frequency        = 0;
+    this.sb_coupling_frequency   = 0;
+    this.checkpoint_frequency    = 0;
+    this.waitonlock              = 0;
+    this.upload_server           = '';
+    this.upload_path             = '';
+    this.upload_login            = '';
+    this.upload_port             = 0;
+    this.upload_filename         = '';
+    this.solver_residue_threshold = 0;
+    this.setdefaultparameters();
+    //}}}
 }
Index: issm/trunk/src/m/classes/issmsettings.py
===================================================================
--- issm/trunk/src/m/classes/issmsettings.py	(revision 25994)
+++ issm/trunk/src/m/classes/issmsettings.py	(revision 26744)
@@ -21,40 +21,38 @@
         self.solver_residue_threshold = 0
 
-    #set defaults
+        # Set defaults
         self.setdefaultparameters()
-
     #}}}
 
     def __repr__(self):  # {{{
-        string = "   general issmsettings parameters:"
-
-        string = "%s\n%s" % (string, fielddisplay(self, "results_on_nodes", "list of output for which results will be output for all the nodes of each element, Use 'all' for all output on nodes."))
-        string = "%s\n%s" % (string, fielddisplay(self, "io_gather", "I / O gathering strategy for result outputs (default 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "lowmem", "is the memory limited ? (0 or 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "output_frequency", "frequency at which results are saved in all solutions with multiple time_steps"))
-        string = "%s\n%s" % (string, fielddisplay(self, "sb_coupling_frequency", "frequency at which StressBalance solver is coupled (default 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "checkpoint_frequency", "frequency at which the runs are being recorded, allowing for a restart"))
-        string = "%s\n%s" % (string, fielddisplay(self, "waitonlock", "maximum number of minutes to wait for batch results, or return 0"))
-        string = "%s\n%s" % (string, fielddisplay(self, "solver_residue_threshold", "throw an error if solver residue exceeds this value (NaN to deactivate)"))
-        return string
+        s = "   general issmsettings parameters:\n"
+        s += '{}\n'.format(fielddisplay(self, "results_on_nodes", "list of output for which results will be output for all the nodes of each element, Use 'all' for all output on nodes."))
+        s += '{}\n'.format(fielddisplay(self, "io_gather", "I / O gathering strategy for result outputs (default 1)"))
+        s += '{}\n'.format(fielddisplay(self, "lowmem", "is the memory limited ? (0 or 1)"))
+        s += '{}\n'.format(fielddisplay(self, "output_frequency", "frequency at which results are saved in all solutions with multiple time_steps"))
+        s += '{}\n'.format(fielddisplay(self, "sb_coupling_frequency", "frequency at which StressBalance solver is coupled (default 1)"))
+        s += '{}\n'.format(fielddisplay(self, "checkpoint_frequency", "frequency at which the runs are being recorded, allowing for a restart"))
+        s += '{}\n'.format(fielddisplay(self, "waitonlock", "maximum number of minutes to wait for batch results, or return 0"))
+        s += '{}\n'.format(fielddisplay(self, "solver_residue_threshold", "throw an error if solver residue exceeds this value (NaN to deactivate)"))
+        return s
     #}}}
 
     def setdefaultparameters(self):  # {{{
-        #are we short in memory ? (0 faster but requires more memory)
+        # Are we short in memory? (0 faster but requires more memory)
         self.lowmem = 0
-        #i / o:
+        # I/O:
         self.io_gather = 1
-        #results frequency by default every step
+        # Results frequency by default every step
         self.output_frequency = 1
-        #coupling frequency of the stress balance solver by default every step
+        # Coupling frequency of the stress balance solver by default every step
         self.sb_coupling_frequency = 1
-        #checkpoints frequency, by default never:
+        # Checkpoints frequency, by default never:
         self.checkpoint_frequency = 0
-        #this option can be activated to load automatically the results
-        #onto the model after a parallel run by waiting for the lock file
-        #N minutes that is generated once the solution has converged
-        #0 to deactivate
-        self.waitonlock = 2**31 - 1
-        #throw an error if solver residue exceeds this value
+        # This option can be activated to load automatically the results onto 
+        # the model after a parallel run by waiting for the lock file N minutes 
+        # that is generated once the solution has converged
+        # Set to 0 to deactivate
+        self.waitonlock = pow(2, 31) - 1
+        # Throw an error if solver residue exceeds this value
         self.solver_residue_threshold = 1e-6
 
